LeetCode 1. 两数之和

思路

方法一:暴力枚举

最容易想到的方法是枚举数组中的每一个数 x,寻找数组中是否存在 target - x。

当我们使用遍历整个数组的方式寻找 target - x 时,需要注意到每一个位于 x 之前的元素都已经和 x 匹配过,因此不需要再进行匹配。而每一个元素不能被使用两次,所以我们只需要在 x 后面的元素中寻找 target - x。

 1 class Solution {
 2 public:
 3     vector<int> twoSum(vector<int>& nums, int target) {
 4         int n = nums.size();
 5         for (int i = 0; i < n; ++i) {
 6             for (int j = i + 1; j < n; ++j) {
 7                 if (nums[i] + nums[j] == target) {
 8                     return {i, j};
 9                 }
10             }
11         }
12         return {};
13     }
14 };

方法二:哈希表

注意到方法一的时间复杂度较高的原因是寻找 target - x 的时间复杂度过高。因此,我们需要一种更优秀的方法,能够快速寻找数组中是否存在目标元素。如果存在,我们需要找出它的索引。

使用哈希表,可以将寻找 target - x 的时间复杂度降低到从 O(N) 降低到 O(1)。

这样我们创建一个哈希表,对于每一个 x,我们首先查询哈希表中是否存在 target - x,然后将 x 插入到哈希表中,即可保证不会让 x 和自己匹配。

 1 class Solution {
 2 public:
 3     vector<int> twoSum(vector<int>& nums, int target) {
 4         unordered_map<int, int> mp;
 5         for(int i = 0; i < nums.size(); ++i) {
 6             if(mp.count(target-nums[i]) == 1) {
 7                 return vector<int>({mp[target-nums[i]], i});
 8             } else {
 9                 mp[nums[i]] = i;
10             }
11         }
12 
13         return vector<int>();
14     }
15 };

原文:LeetCode官方题解 - 两数之和

原文地址:https://www.cnblogs.com/FengZeng666/p/14462282.html